<template>
  <a-card :bordered='false'>
    <div class='table-page-search-wrapper'>
      <a-form layout='inline'>
        <a-row :gutter='48'>
          <a-col :md='5' :sm='15'>
            <a-form-item label='姓名'>
              <a-input placeholder='请输入姓名' v-model='queryParam.name' />
            </a-form-item>
          </a-col>
          <a-col :md='8' :sm='24'>
            <span class='table-page-search-submitButtons'>
              <a-button type='primary' @click='$refs.table.refresh(true)'>查询</a-button>
              <a-button style='margin-left: 8px' @click='() => queryParam = {}'>重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <div class='table-operator'>
      <a-button v-if='addEnable' type='primary' icon='plus' @click='$refs.modal.add()'>新建</a-button>
      <a-dropdown v-if='removeEnable&&selectedRowKeys.length > 0'>
        <a-button type='danger' icon='delete' @click='delByIds(selectedRowKeys)'>删除</a-button>
      </a-dropdown>
    </div>
    <s-table
      size='default'
      ref='table'
      rowKey='id'
      :rowSelection='{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}'
      :columns='columns'
      :data='loadData'
    >
      <span slot='status' slot-scope='text, record'>
       <a-tag v-if='record.status == 0' color="orange">
        未审核
      </a-tag>
      <a-tag v-if='record.status == 1' color="green">
        审核通过
      </a-tag>
      <a-tag v-if='record.status == 2' color="red">
        审核驳回
      </a-tag>
      </span>
      <span slot='photo' slot-scope='text, record'>
       <img :src='baseUrl + record.photo' style='max-width: 100px; max-height: 120px'>
      </span>
      <span slot='action' slot-scope='text, record'>
        <a @click='handleInfo(record)'>详情</a>
        <a-divider type='vertical' />
        <a v-if='editEnabel' @click='handleEdit(record)'>编辑</a>
        <a-divider type='vertical' />
        <a v-if='removeEnable' @click='deleteShow([record.id])'>删除</a>
              <a-divider type='vertical' />
      <a-tag @click='verifySuccess(record,1)' v-if='record.status == 0' color='green'>通过</a-tag>
      <a-tag @click='verifyReject(record.id)' v-if='record.status == 0 '
             color='volcano'>驳回</a-tag>
      </span>

    </s-table>


    <a-modal
      title='提示'
      :visible='deleteVisible'
      :confirm-loading='deleteLoading'
      @ok='deleteOk'
      @cancel='deleteCancel'
    >
      <p>是否确认删除？</p>
    </a-modal>

    <visitorPerson-modal ref='modal' @ok='handleOk' />

    <a-modal
      title='驳回'
      :visible='rejectModalVisible'
      :confirm-loading='rejectConfirmLoading'
      @ok='rejectHandleOk'
      @cancel='rejectHandleCancel'
      cancelText='取消'
      okText='确认'
    >
      <div class='rejectView'>
        <div class='label'>驳回原因</div>
        <a-input class='content' v-model='rejectContent' placeholder='请输入驳回原因' />
      </div>
    </a-modal>
  </a-card>
</template>

<script>
import { STable } from '@/components'

import { delVisitorPerson, getVisitorPersonList,saveVisitorPerson } from '@/api/admin/meeting/visitorPerson'
import VisitorPersonModal from './modules/VisitorPersonModal.vue'
import { checkPermission } from '@/utils/permissions'

export default {
  name: 'TableList',
  components: {
    STable,
    VisitorPersonModal
  },
  data() {
    return {
      baseUrl: process.env.VUE_APP_API_BASE_URL,
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      },
      form: this.$form.createForm(this),
      mdl: {},
      // 高级搜索 展开/关闭
      advanced: false,
      // 查询参数
      queryParam: {},
      rejectModalId: null,
      rejectContent: null,
      rejectModalVisible: false,
      rejectConfirmLoading: false,
      // 表头
      columns: [
        {
          title: '访客姓名',
          dataIndex: 'name'
        },
        {
          title: '访客联系方式',
          dataIndex: 'phone'
        },
        {
          title: '到访时间',
          dataIndex: 'visitTime',
          sorter: true
        },
        {
          title: '离开时间',
          dataIndex: 'leaveTime',
          sorter: true
        },
        {
          title: '状态',
          dataIndex: 'status',
          scopedSlots: {customRender:  'status'}
        },
        {
          title: '照片',
          dataIndex: 'photo',
          scopedSlots: { customRender: 'photo' }
        },
        {
          title: '操作',
          width: '200px',
          dataIndex: 'action',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        return getVisitorPersonList(Object.assign(parameter, this.queryParam))
      },
      selectedRowKeys: [],
      selectedRows: [],
      addEnable: checkPermission('meeting:visitorPerson:add'),
      editEnabel: checkPermission('meeting:visitorPerson:edit'),
      removeEnable: checkPermission('meeting:visitorPerson:remove'),
      // 删除
      deleteVisible: false,
      deleteLoading: false,
      deleteIds : null,
    }
  },
  filters: {},
  created() {
  },
  methods: {
    verifySuccess(record,status){
      record.status = status
      saveVisitorPerson(record).then(res => {
        if (res.code === 0) {
          this.$message.success('审核通过')
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    },
    verifyReject(id) {
      this.rejectModalId = id
      this.rejectModalVisible = true
    },
    rejectHandleOk() {
      console.log('rejectHandleOk', this.rejectContent)
      let id = this.rejectModalId
      let cancelResaon = this.rejectContent
      // 校验必填
      if (!this.rejectContent) {
        this.$message.error('驳回原因不能为空!')
        return
      }
      // 设置确认加载状态
      this.rejectConfirmLoading = true
      // 调用接口
      saveVisitorPerson({
        id,
        status: 2,
        rejectContent:this.rejectContent,
      }).then(res => {
        if (res.code === 0) {
          this.$message.success('操作成功')
          this.rejectHandleCancel()
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    },
    rejectHandleCancel() {
      this.rejectModalId = null
      this.rejectModalVisible = false
      this.rejectConfirmLoading = false
      this.rejectContent = null
    },

    onSelectChange(selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    //详情，跳转页面
    handleInfo(record) {
      console.log('handleInfo', record)
      this.$router.push({ name: 'visitorPersonInfo', query: { id: record.id } })
    },
    handleAdd() {
      this.$refs.modal.add()
    },
    handleEdit(record) {
      this.$refs.modal.edit(record)
    },
    handleOk() {
      this.$refs.table.refresh(true)
      console.log('handleSaveOk')
    },
    delByIds(ids) {
      delVisitorPerson({ ids: ids.join(',') }).then(res => {
        if (res.code === 0) {
          this.$message.success('删除成功')
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
        // 删除结束
        this.deleteVisible = false
        this.deleteLoading = false
      })
    },
    deleteShow(ids) {
      this.deleteVisible = true
      this.deleteIds = ids
    },
    deleteOk() {
      this.deleteLoading = true;
      this.delByIds(this.deleteIds)
    },
    deleteCancel() {
      this.deleteVisible = false
    },
  },
  watch: {
    /*
      'selectedRows': function (selectedRows) {
        this.needTotalList = this.needTotalList.map(item => {
          return {
            ...item,
            total: selectedRows.reduce( (sum, val) => {
              return sum + val[item.dataIndex]
            }, 0)
          }
        })
      }
      */
  }
}
</script>
